<template>
  <div class="app-container">

    <!-- 查询和其他操作 -->
    <div class="filter-container">
      <el-input v-model="listQuery.name" clearable class="filter-item" style="width: 200px;" placeholder="请输入任务名称" />
      <el-button v-permission="['GET /admin/campaign/list']" class="filter-item" type="primary" icon="el-icon-search" @click="handleFilter">查找</el-button>
      <el-button v-permission="['POST /admin/campaign/create']" class="filter-item" type="primary" icon="el-icon-edit" @click="handleCreate">添加</el-button>
    </div>

    <!-- 查询结果 -->
    <el-table v-loading="listLoading" :data="list" element-loading-text="正在查询中。。。" border fit highlight-current-row>

      <el-table-column align="center" label="任务名" prop="name" />

      <el-table-column align="center" label="类型" prop="type">
        <template slot-scope="scope">
          <el-tag :type="scope.row.type==0 ? 'success' : 'error' ">{{ scope.row.type==0 ? '自定义任务' : '导入任务' }}</el-tag>
        </template>
      </el-table-column>

      <el-table-column align="center" label="是否自动分配" prop="isAutoDis">
        <template slot-scope="scope">{{ filterBoolen(scope.row.isAutoDis) }}</template>
      </el-table-column>

      <el-table-column align="center" label="运行频次" prop="isNightRun">
        <template slot-scope="scope">{{ filterRun(scope.row.isNightRun) }}</template>
      </el-table-column>

      <el-table-column align="center" label="是否启用" prop="deleted">
        <template slot-scope="scope">
          <el-tag :type="scope.row.deleted ? 'success' : 'error' ">{{ scope.row.deleted ? '不启用' : '启用' }}</el-tag>
        </template>
      </el-table-column>

      <el-table-column align="center" label="创建时间" prop="createTime" />

      <el-table-column align="center" label="操作" width="200" class-name="small-padding fixed-width">
        <template slot-scope="scope">
          <el-button v-permission="['POST /admin/campaign/update']" type="primary" size="mini" @click="handleUpdate(scope.row)">编辑</el-button>
          <el-button v-permission="['POST /admin/campaign/delete']" type="danger" size="mini" @click="handleDelete(scope.row)">删除</el-button>
        </template>
      </el-table-column>
    </el-table>

    <pagination v-show="total>0" :total="total" :page.sync="listQuery.page" :limit.sync="listQuery.limit" @pagination="getList" />

    <!-- 添加或修改对话框 -->
    <el-dialog :title="textMap[dialogStatus]" :visible.sync="dialogFormVisible">
      <el-form ref="dataForm" :rules="rules" :model="dataForm" status-icon label-position="left" label-width="100px" style="width: 600px; margin-left:50px;">
        <el-form-item label="任务标题" prop="name">
          <el-input v-model.trim="dataForm.name" placeholder="请输入任务名称" />
        </el-form-item>

        <el-form-item label="类型" prop="type">
          <el-radio-group v-model="dataForm.type">
            <el-radio :label="0">自定义条件</el-radio>
            <el-radio :label="1">导入任务</el-radio>
          </el-radio-group>
        </el-form-item>

        <el-form-item label="是否自动分配" prop="isAutoDis">
          <el-radio-group v-model="dataForm.isAutoDis">
            <el-radio :label="true">是</el-radio>
            <el-radio :label="false">否</el-radio>
          </el-radio-group>
        </el-form-item>

        <el-form-item label="运行频次" prop="isNightRun">
          <el-radio-group v-model="dataForm.isNightRun">
            <el-radio :label="true">每日一次</el-radio>
            <el-radio :label="false">实时</el-radio>
          </el-radio-group>
        </el-form-item>

        <el-form-item label="自定义SQL" prop="customSql">
          <el-input v-model="dataForm.customSql" type="textarea" placeholder="如需填写此字段 请与研发或产品协助" />
        </el-form-item>

        <el-form-item label="话术" prop="faq">
          <el-input v-model="dataForm.faq" type="textarea" />
        </el-form-item>

      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button @click="dialogFormVisible = false">取消</el-button>
        <el-button v-if="dialogStatus=='create'" type="primary" @click="createData">确定</el-button>
        <el-button v-else type="primary" @click="updateData">确定</el-button>
      </div>
    </el-dialog>

  </div>
</template>

<script>
import { listAd, createAd, updateAd, deleteAd } from '@/api/campaign'
import { uploadPath } from '@/api/storage'
import { getToken } from '@/utils/auth'
import Pagination from '@/components/Pagination' // Secondary package based on el-pagination

export default {
  name: 'Campaign',
  components: { Pagination },
  data() {
    return {
      uploadPath,
      list: [],
      total: 0,
      listLoading: true,
      listQuery: {
        name: undefined,
        page: 1,
        limit: 20,
        sort: 'id',
        order: 'desc'
      },
      dataForm: {
        id: undefined,
        name: undefined,
        type: 0,
        deleted: false,
        isAutoDis: true,
        isNightRun: false,
        custom_sql: undefined,
        remark: undefined
      },
      dialogFormVisible: false,
      dialogStatus: '',
      textMap: {
        update: '任务编辑',
        create: '任务创建'
      },
      rules: {
        name: [{ required: true, message: '任务标题不能为空', trigger: 'blur' }]
      }
    }
  },
  computed: {
    headers() {
      return {
        'X-JZ-Admin-Token': getToken()
      }
    }
  },
  created() {
    console.info(this.listQuery)
    this.getList()
  },
  methods: {
    filterBoolen(value) {
      if (value == 1) return '是'
      else return '否'
    },
    filterRun(value) {
      if (value == 1) return '每日一次'
      else return '实时'
    },
    isInputValid(rule, value, callback) {
      if (value == null || value.trim() == '') { return callback(new Error('请输入参数或值')) } else return callback()
    },
    getList() {
      this.listLoading = true
      listAd(this.listQuery)
        .then(response => {
          this.list = response.data.data.list
          this.total = response.data.data.total
          this.listLoading = false
        })
        .catch(() => {
          this.list = []
          this.total = 0
          this.listLoading = false
        })
    },
    handleFilter() {
      this.listQuery.page = 1
      this.getList()
    },
    resetForm() {
      this.dataForm = {
        id: undefined,
        name: undefined,
        type: 0,
        deleted: false,
        isAutoDis: true,
        isNightRun: false,
        custom_sql: undefined,
        remark: undefined
      }
    },
    handleCreate() {
      this.resetForm()
      this.dialogStatus = 'create'
      this.dialogFormVisible = true
      this.$nextTick(() => {
        this.$refs['dataForm'].clearValidate()
      })
    },
    uploadUrl: function(response) {
      this.dataForm.url = response.data.url
    },
    checkFileSize: function(file) {
      if (file.size > 1048576) {
        this.$message.error(`${file.name}文件大于1024KB，请选择小于1024KB大小的图片`)
        return false
      }
      return true
    },
    createData() {
      this.$refs['dataForm'].validate(valid => {
        if (valid) {
          createAd(this.dataForm)
            .then(response => {
              this.list.unshift(response.data.data)
              this.dialogFormVisible = false
              this.$notify.success({
                title: '成功',
                message: '创建成功'
              })
            })
            .catch(response => {
              this.$notify.error({
                title: '失败',
                message: response.data.errmsg
              })
            })
        }
      })
    },
    handleUpdate(row) {
      this.dataForm = Object.assign({}, row)
      this.dialogStatus = 'update'
      this.dialogFormVisible = true
      this.$nextTick(() => {
        this.$refs['dataForm'].clearValidate()
      })
    },
    updateData() {
      this.$refs['dataForm'].validate(valid => {
        if (valid) {
          updateAd(this.dataForm)
            .then(() => {
              for (const v of this.list) {
                if (v.id === this.dataForm.id) {
                  const index = this.list.indexOf(v)
                  this.list.splice(index, 1, this.dataForm)
                  break
                }
              }
              this.dialogFormVisible = false
              this.$notify.success({
                title: '成功',
                message: '更新广告成功'
              })
            })
            .catch(response => {
              this.$notify.error({
                title: '失败',
                message: response.data.errmsg
              })
            })
        }
      })
    },
    handleDelete(row) {
      deleteAd(row)
        .then(response => {
          this.$notify.success({
            title: '成功',
            message: '删除成功'
          })
          const index = this.list.indexOf(row)
          this.list.splice(index, 1)
        })
        .catch(response => {
          this.$notify.error({
            title: '失败',
            message: response.data.errmsg
          })
        })
    }
  }
}
</script>

<style>
.avatar-uploader .el-upload {
  border: 1px dashed #d9d9d9;
  border-radius: 6px;
  cursor: pointer;
  position: relative;
  overflow: hidden;
}
.avatar-uploader .el-upload:hover {
  border-color: #20a0ff;
}
.avatar-uploader-icon {
  font-size: 28px;
  color: #8c939d;
  width: 120px;
  height: 120px;
  line-height: 120px;
  text-align: center;
}
.avatar {
  width: 145px;
  height: 145px;
  display: block;
}
  .el-table th.gutter{
          display: table-cell!important;
        }
</style>
